
#include <fstream>
#include <string>
#include <vector>
#define SQR(x) (x)*(x)
struct Word
{
	char type; /// The character of the  GCODE word, e.g. 'G' or 'F'
	std::string text; ///the literal text of the value of the word
	bool isExpression; /// is [] expression 
	bool isVariable; /// specified with '#', <> not supported yet
	float value; /// only set if its a normal number and not an expression. in the future, would be nice if expressions are interpreted
};
std::string modify(Word &w, float scale, float shift=0);

class GDecoder
{
public:
	GDecoder();
	~GDecoder();
	int open(const char *filename);
	void nextLine(); //process next line
	
	
	inline bool good(){return gc.good();}
	
private:
	void moveto(float &target,float &old,float &change); /// process movement to know current location and direction
	
public:
	
	bool moveAbsolute;
	bool g1;
	float curPos[3]; //position after this line of gcode
	float lastPos[3]; // position before this line
	float lastDir[3]; // direction of last move; for knive-cutting delay compensation
	std::string wholeline; // the text of the complete line
	bool lhasx,lhasy,lhasboth; // line has '' word
	int gnr;
	std::vector<Word>  wd; //array of the single words in this line. 
private:
	std::fstream gc; //the input file stream
	bool debug; //extra output to cerr
	
	
};
